<template>
  <div class="container py-10 h-auto px-6 mx-auto">
    <div class="mt-6 max-w-2xl mx-auto sm:px-6 lg:max-w-7xl lg:px-8">
      <div class="w-32">
        <router-link to="/catalog">
          <span
            class="mb-10 text-white bg-indigo-700 hover:bg-indigo-800 focus:ring-4 focus:ring-indigo-300 font-medium rounded-lg text-sm px-3 py-2 text-center inline-flex items-center  dark:bg-indigo-600 dark:hover:bg-indigo-700 dark:focus:ring-indigo-800"
          >
            Retour au catalogue
          </span>
        </router-link>
      </div>

      <div
        v-if="game.image"
        class="my-6 max-w-2xl mx-auto px-6 lg:max-w-7xl lg:px-8"
      >
        <div
          class="aspect-w-3 aspect-h-4 rounded-lg overflow-hidden"
        >
          <img
            :src="game.image"
            :alt="game.name"
            class="w-full h-full object-center object-cover"
          />
        </div>
      </div>

      <div>
        {{ game.studio ? game.studio.name : null }}
      </div>
      <div class="flex justify-end h-8 gap-4">
        <div v-if="!game.studio" @click="redeemGame">
          <Button
            v-if="this.user ? user.roles.includes('ROLE_STUDIO') : false"
            icon="bookmark"
            padding_y="4"
          />
        </div>
        <div @click="addToWish">
          <Button
            v-if="user"
            icon="cart-plus"
            padding_y="4"
            :color="game.wished ? 'yellow' : 'indigo'"
          />
        </div>
        <div @click="addLike">
          <Button
            icon="thumbs-up"
            :label="game.likes ? game.likes.toString() : '0'"
            :color="game.hasLiked ? 'green' : 'indigo'"
          />
        </div>
      </div>
    </div>

    <div class="mt-6 max-w-2xl mx-auto sm:px-6 lg:max-w-7xl lg:px-8">
      <h1
        class="text-2xl font-extrabold tracking-tight text-gray-900 sm:text-3xl"
      >
        {{ game.name }}
      </h1>

      <div class="my-8">
        <h2>Site de vente</h2>
        <div class="my-4 flex flex-cols-3 gap-4">
          <component
            :is="
              game.urlRedirects.find((obj) => {
                return obj.libelle === 'steam'
              })
                ? 'a'
                : 'span'
            "
            :href="
              game.urlRedirects.find((obj) => {
                return obj.libelle === 'steam'
              })
                ? game.urlRedirects.find((obj) => {
                    return obj.libelle === 'steam'
                  }).url
                : ''
            "
            target="_blank"
          >
            <font-awesome-icon :icon="['fab', 'steam']" size="2x" />
          </component>

          <component
            :is="
              game.urlRedirects.find((obj) => {
                return obj.libelle === 'epic'
              })
                ? 'a'
                : 'span'
            "
            :href="
              game.urlRedirects.find((obj) => {
                return obj.libelle === 'epic'
              })
                ? game.urlRedirects.find((obj) => {
                    return obj.libelle === 'epic'
                  }).url
                : ''
            "
            target="_blank"
          >
            <span class="icon-epic-games"
              ><span class="path1"></span><span class="path2"></span
            ></span>
          </component>

          <component
            :is="
              game.urlRedirects.find((obj) => {
                return obj.libelle === 'autre'
              })
                ? 'a'
                : 'span'
            "
            :href="
              game.urlRedirects.find((obj) => {
                return obj.libelle === 'autre'
              })
                ? game.urlRedirects.find((obj) => {
                    return obj.libelle === 'autre'
                  }).url
                : ''
            "
            target="_blank"
          >
            <font-awesome-icon icon="globe" size="2x" />
          </component>
        </div>
      </div>
    </div>

    <div class="mt-6 max-w-2xl mx-auto sm:px-6 lg:max-w-7xl lg:px-8">
      <div>
        <h2
          class="text-2xl font-extrabold tracking-tight text-gray-900 sm:text-3xl"
        >
          Commentaires
        </h2>
        <div class="mt-8">
          <div v-if="user">
            <form method="POST" @submit="postComment">
              <TextAreaField
                id="comment"
                name="comment"
                :value="comment"
                @input="values[$event.target.name] = $event.target.value"
                required
              />
              <Button type="submit" icon="paper-plane" label="Commenter" />
            </form>
          </div>
          <div v-else>
            Connectez-vous pour commenter
          </div>
          <div
            class="my-4"
            v-for="(comment, key) in gameComment.slice().reverse()"
            :key="key"
          >
            <CommentCard
              :author="comment.author"
              :message="comment.content"
              :date="comment.date"
              :id="comment._id"
              @delete="() => deleteComment(key)"
            />
          </div>
          <div></div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Button from "./Button"
import TextAreaField from "./Form/Field/TextAreaField"
import CommentCard from "./CommentCard"

export default {
  name: "Game",
  components: {
    Button,
    TextAreaField,
    CommentCard
  },
  data() {
    return {
      game: [],
      gameComment: [],
      values: {
        comment: ""
      },
      urlGetGames: `https://${window.location.hostname}:8443/games`,
      urlGameComment: `https://${window.location.hostname}:8443/comment`,
      urlGetComment: `https://${window.location.hostname}:8443/comment/game`,
      urlGameLike: `https://${window.location.hostname}:8443/like`,
      urlGameWish: `https://${window.location.hostname}:8443/wish`,
      urlGameClaim: `https://${window.location.hostname}:8443/game_claims`,
      urlGetUser: `https://${window.location.hostname}:8443/users/`
    }
  },
  inject: ["user", "createAlert"],
  beforeMount() {
    const headers = this.user
      ? {
          Accept: "application/json",
          "Content-Type": "application/json",
          Authorization: "Bearer " + this.user.token
        }
      : {
          Accept: "application/json",
          "Content-Type": "application/json"
        }

    fetch(this.urlGetComment + "/" + this.$route.params.id, {
      headers,
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        data.forEach(el => {
          el.author = "Anonyme"
          this.gameComment.push(el)
        })
      })
      .catch(() => {
        this.$router.push("/404")
        this.createAlert({
          color: "red",
          text: "Ce jeu n'existe pas",
          icon: "times"
        })
      })

    fetch(this.urlGetGames + "/" + this.$route.params.id, {
      headers,
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        this.game = data
      })
      .catch(() => {
        this.$router.push("/404")
        this.createAlert({
          color: "red",
          text: "Ce jeu n'existe pas",
          icon: "times"
        })
      })
  },
  methods: {
    addLike: function() {
      if (!this.user) {
        return this.createAlert({
          color: "red",
          text: "Vous devez être connecté pour liker un jeu",
          icon: "times"
        })
      }

      const headers = this.user
        ? {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer " + this.user.token
          }
        : {
            Accept: "application/json",
            "Content-Type": "application/json"
          }

      const body = {
        game_id: this.$route.params.id,
        user_id: this.user.id
      }

      if (this.game.hasLiked) {
        fetch(this.urlGameLike, {
          headers,
          method: "DELETE",
          body: JSON.stringify(body)
        })
          .then((res) => {
            if (res.status == 204) {
              this.game.likes -= 1
              this.game.hasLiked = false
            } else {
              throw new Error("Something went wrong")
            }
          })
          .catch(() => {
            this.createAlert({
              color: "red",
              text: "Une erreur est survenue",
              icon: "times"
            })
          })
      } else {
        fetch(this.urlGameLike, {
          headers,
          method: "POST",
          body: JSON.stringify(body)
        })
          .then((res) => {
            if (res.ok) {
              return res.json()
            } else {
              throw new Error("Something went wrong")
            }
          })
          .then((data) => {
            this.game.likes += 1
            this.game.hasLiked = true
          })
          .catch(() => {
            this.createAlert({
              color: "red",
              text: "Une erreur est survenue",
              icon: "times"
            })
          })
      }
    },
    addToWish: function() {
      if (!this.user) {
        return this.createAlert({
          color: "red",
          text: "Vous devez être connecté pour liker un jeu",
          icon: "times"
        })
      }

      const headers = this.user
        ? {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer " + this.user.token
          }
        : {
            Accept: "application/json",
            "Content-Type": "application/json"
          }

      const body = {
        game_id: this.$route.params.id,
        user_id: this.user.id
      }

      if (this.game.wished) {
        fetch(this.urlGameWish, {
          headers,
          method: "DELETE",
          body: JSON.stringify(body)
        })
          .then((res) => {
            if (res.status == 204) {
              this.game.wished = false
            } else {
              throw new Error("Something went wrong")
            }
          })
          .catch(() => {
            this.createAlert({
              color: "red",
              text: "Une erreur est survenue",
              icon: "times"
            })
          })
      } else {
        fetch(this.urlGameWish, {
          headers,
          method: "POST",
          body: JSON.stringify(body)
        })
          .then((res) => {
            if (res.ok) {
              return res.json()
            } else {
              throw new Error("Something went wrong")
            }
          })
          .then((data) => {
            this.game.wished = true
          })
          .catch(() => {
            this.createAlert({
              color: "red",
              text: "Une erreur est survenue",
              icon: "times"
            })
          })
      }
    },
    postComment: function(e) {
      e.preventDefault()

      const headers = this.user
        ? {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer " + this.user.token
          }
        : {
            Accept: "application/json",
            "Content-Type": "application/json"
          }

      const commentDateTime = new Date()

      const body = {
        game_id: this.$route.params.id,
        user_id: this.user.id,
        content: this.values.comment,
        date: commentDateTime
      }

      fetch(this.urlGameComment, {
        headers,
        method: "POST",
        body: JSON.stringify(body)
      })
        .then((res) => {
          if (res.ok) {
            return res.json()
          } else {
            throw new Error("Something went wrong")
          }
        })
        .then((data) => {
          this.$router.go()
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    },
    redeemGame: function() {
      const headers = {
        Accept: "application/json",
        "Content-Type": "application/json",
        Authorization: "Bearer " + this.user.token
      }

      const body = {
        claimer: "/studios/" + this.user.studio,
        game: "/games/" + this.$route.params.id
      }

      fetch(this.urlGameClaim, {
        headers,
        method: "POST",
        body: JSON.stringify(body)
      })
        .then((res) => {
          if (res.ok) {
            return res.json()
          } else {
            throw new Error("Something went wrong")
          }
        })
        .then((data) => {
          this.createAlert({
            color: "green",
            text: "Votre demande a été envoyée",
            icon: "check"
          })
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    },
    deleteComment: function(key) {
      this.gameComment.splice(key, 1)
      this.$router.go()
    }
  }
}
</script>

<style scoped></style>
